%LAST UPDATED: 10/29/2014

function varargout = PIVdiadenGUI(varargin)
% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @PIVdiadenGUI_OpeningFcn, ...
    'gui_OutputFcn',  @PIVdiadenGUI_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


%% opening funciton for figure
function PIVdiadenGUI_OpeningFcn(hObject, eventdata, handles, varargin)

handles.syscolor=get(hObject,'color');
handles.loaddirec=[pwd '\'];

%Reading information
handles.data.imdirec=pwd;
handles.data.imbase='B';
handles.data.imzeros='5';
handles.data.imext='im7';
% handles.data.imcstep='0';
handles.data.imfstep='1';
handles.data.imfstart='1';
handles.data.imfend='2';

%Write controls
handles.data.batchname='Proc1';
handles.data.imNum = '1';
handles.data.DiaGS = '2';
handles.data.dens='';
handles.data.diam='';
handles.data.hardDens='0';
handles.data.hardDia='0';
handles.data.Plot='0';
handles.data.bkgd='1';
handles.data.OutDia='1';
handles.data.OutDen='1';
handles.data.OutLM='0';
handles.data.OutCorr='0';
handles.data.OutRatio='0';
handles.data.SaveBkgd='0';

handles.data.outbase='DiaDenResults';
handles.data.outdirec=pwd;
handles.data.par='0';
handles.data.parprocessors='2';

handles.data0=handles.data;
handles.Njob=num2str(size(get(handles.listbox5,'String'),1));
handles.Cjob=num2str(get(handles.listbox5,'String'));
handles=rmfield(handles,'data');
handles=update_data(handles);
handles.output = hObject;
guidata(hObject, handles);

%output
function varargout = PIVdiadenGUI_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;


%% Use Image
function popupmenu4_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.imNum= num2str(get(handles.popupmenu4,'Value'));
    guidata(hObject,handles)
end
function popupmenu4_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Diameter Grid Size
function popupmenu12_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.DiaGS= num2str(get(handles.popupmenu12,'Value'));
    guidata(hObject,handles)
end
function popupmenu12_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Hardcode Particle Diameter
function edit26_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.diam = get(hObject,'String');
    guidata(hObject,handles)
    if str2double(get(hObject,'String'))<=0
        set(hObject,'backgroundcolor','r')
    else
        set(hObject,'backgroundcolor',[1 1 1])
    end
end
function edit26_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Output Name
function edit31_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.outbase = get(hObject,'String');
    guidata(hObject,handles)
end
function edit31_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Image File Directory
function edit32_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.imdirec = get(hObject,'String');
    
    listOfFiles = dir([handles.data.imdirec '\' handles.data.imbase '*.' handles.data.imext]);
    handles.data.imfend=num2str(numel(listOfFiles));
    set(handles.edit39,'string',handles.data.imfend);
    
    load_imlist(handles);
    guidata(hObject,handles)
end
function edit32_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Select First Image
function pushbutton24_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    D = handles.data.imdirec;
    B = handles.data.imbase;
    Z = handles.data.imzeros;
    E = handles.data.imext;
    S = handles.data.imfstart;
    F = handles.data.imfend;
    [imname,handles.data.imdirec] = uigetfile('*.*','Select an image file',handles.data.imdirec);
    if handles.data.imdirec==0
        handles.data.imdirec = D;
        handles.data.imbase = B;
        handles.data.imzeros = Z;
        handles.data.imext = E;
        handles.data.imfstart = S;
        handles.data.imfend = F;
    else
        i=strfind(imname,'.');
        handles.data.imext=imname((i+1):end);
        fstart=0;zeros=0;
        while ~isnan(fstart)
            zeros=zeros+1;
            fstart=str2double(imname((i-zeros):(i-1)));
        end
        handles.data.imzeros=num2str(zeros-1);
        fstart=str2double(imname((i-(zeros-1)):(i-1)));
        handles.data.imfstart=num2str(fstart);
        handles.data.imfend=num2str(fstart);
        handles.data.imbase=imname(1:(i-zeros));
    end
    set(handles.edit32,'string',handles.data.imdirec);
    set(handles.edit34,'string',handles.data.imbase);
    set(handles.edit44,'string',handles.data.imzeros);
    set(handles.edit35,'string',handles.data.imext);
    set(handles.edit38,'string',handles.data.imfstart);
    listOfFiles = dir([handles.data.imdirec '\' handles.data.imbase '*.' handles.data.imext]);
    handles.data.imfend=num2str(numel(listOfFiles));
    set(handles.edit39,'string',handles.data.imfend);
    
    load_imlist(handles);
    guidata(hObject,handles)
end


%% output directory
function edit33_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.outdirec = get(hObject,'String');
    guidata(hObject,handles)
end
function edit33_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% browse output directory
function pushbutton10_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    D = handles.data.outdirec;
    handles.data.outdirec = uigetdir(handles.data.outdirec);
    if handles.data.outdirec==0
        handles.data.outdirec = D;
    end
    set(handles.edit33,'string',handles.data.outdirec);
    guidata(hObject,handles)
end


%% image list
function listbox4_Callback(hObject, eventdata, handles)
function listbox4_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% image base name
function edit34_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.imbase = get(hObject,'String');
    load_imlist(handles);
    guidata(hObject,handles)
end
function edit34_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% image extension
function edit35_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.imext = get(hObject,'String');
    if strcmp(handles.data.imext(1),'.')
        set(hObject,'backgroundcolor','r');
    else
        set(hObject,'backgroundcolor',[1 1 1]);
    end
    load_imlist(handles);
    guidata(hObject,handles)
end
function edit35_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% image pair step
% function edit36_Callback(hObject, eventdata, handles)
% if str2double(handles.Njob)>0
%     handles.data.imcstep = get(hObject,'String');
%     load_imlist(handles);
%     guidata(hObject,handles)
% end
% function edit36_CreateFcn(hObject, eventdata, handles)
% if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%     set(hObject,'BackgroundColor','white');
% end


%% image frame step
function edit37_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.imfstep = get(hObject,'String');
    load_imlist(handles);
    guidata(hObject,handles)
end
function edit37_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% image frame start
function edit38_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.imfstart = get(hObject,'String');
    load_imlist(handles);
    guidata(hObject,handles)
end
function edit38_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% image frame end
function edit39_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.imfend = get(hObject,'String');
    load_imlist(handles);
    guidata(hObject,handles)
end
function edit39_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Job Name
function edit42_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    Jlist0=char(get(handles.listbox5,'String'));
    handles=rmfield(handles,handles.data.batchname);
    handles.data.batchname = get(hObject,'String');
    Jlist=cell(str2double(handles.Njob),1);
    for e=1:str2double(handles.Njob)
        if e==str2double(handles.Cjob)
            Jlist(e)={handles.data.batchname};
        else
            Jlist(e)={Jlist0(e,:)};
        end
    end    
    handles=setfield(handles,handles.data.batchname,handles.data);
    set(handles.listbox5,'String',char(Jlist));
    guidata(hObject,handles)
end
function edit42_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% image file zeros
function edit44_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.imzeros = get(hObject,'String');
    load_imlist(handles);
    guidata(hObject,handles)
end
function edit44_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



%% Run In Parallel Checkbox
function checkbox16_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.par=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
    if str2double(handles.data.par)==0
        set(handles.edit69,'backgroundcolor',0.5*[1 1 1]);
    else
        set(handles.edit69,'backgroundcolor',[1 1 1]);
    end 
end


%% Particle Density Hardcode
function checkbox18_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.hardDens=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
    
    if str2double(handles.data.hardDens)==0
        set(handles.edit48,'backgroundcolor',0.5*[1 1 1]);
    else
        set(handles.edit48,'backgroundcolor',[1 1 1]);
    end
end


%% Particle Diameter Hardcode
function checkbox19_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.hardDia=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
    if str2double(handles.data.hardDia)==0
        set(handles.edit26,'backgroundcolor',0.5*[1 1 1]);
    else
        set(handles.edit26,'backgroundcolor',[1 1 1]);
    end  
end


%% Plot Average of Dia/Den
function checkbox22_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.Plot=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
end


%% Background image removal
function checkbox23_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.bkgd=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
end

%% Save Background Image
function checkbox24_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.SaveBkgd=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
end


%% load IM list
function load_imlist(handles)
dir_struct = dir(handles.data.imdirec);
if isempty(dir_struct)
    set(handles.edit32,'backgroundcolor','r');
else
    set(handles.edit32,'backgroundcolor',[1 1 1]);
end
N=length(str2double(handles.data.imfstart):str2double(handles.data.imfstep):str2double(handles.data.imfend));
files = cell(N,1);
e=0;
for f=str2double(handles.data.imfstart):str2double(handles.data.imfstep):str2double(handles.data.imfend)
    e=e+1;
    files(e,1)={[handles.data.imbase sprintf(['%0.' handles.data.imzeros 'i.' handles.data.imext],f)]};
%     files(e,2)={[handles.data.imbase sprintf(['%0.' handles.data.imzeros 'i.' handles.data.imext],f+str2double(handles.data.imcstep))]};
end

[sorted_names,sorted_index] = sortrows({dir_struct.name}');
[files1,id,id1] = intersect(sorted_names,files(:,1));
% [files2,id,id2] = intersect(sorted_names,files(:,2));
% [idf]=intersect(id1,id2);
if isempty(id1)
    set(handles.listbox4,'backgroundcolor','r');
else
    set(handles.listbox4,'backgroundcolor',[1 1 1]);
    if length(id1)~=size(files,1)
        set(handles.listbox4,'backgroundcolor','r');
    end
end
files=files(id1,:);
filesf=cell(length(files),1);
for e=1:size(files,1)
    filesf(e)={char(files(e,1))};
end
set(handles.listbox4,'String',filesf,'Value',1)


%% load extra data
function [handles]=load_data(handles)
set(handles.edit26,'String',handles.data.diam);

set(handles.edit31,'String',handles.data.outbase);
set(handles.edit32,'String',handles.data.imdirec);
set(handles.edit33,'String',handles.data.outdirec);
set(handles.edit34,'String',handles.data.imbase);
set(handles.edit35,'String',handles.data.imext);
% set(handles.edit36,'String',handles.data.imcstep);
set(handles.edit37,'String',handles.data.imfstep);
set(handles.edit38,'String',handles.data.imfstart);
set(handles.edit39,'String',handles.data.imfend);
set(handles.edit42,'String',handles.data.batchname);
set(handles.edit44,'String',handles.data.imzeros);
set(handles.edit48,'String',handles.data.dens);
set(handles.edit69,'String',handles.data.parprocessors);
set(handles.checkbox16,'Value',str2double(handles.data.par));
set(handles.checkbox18,'Value',str2double(handles.data.hardDens));
set(handles.checkbox19,'Value',str2double(handles.data.hardDia));
set(handles.checkbox22,'Value',str2double(handles.data.Plot));
set(handles.checkbox23,'Value',str2double(handles.data.bkgd));
set(handles.checkbox24,'Value',str2double(handles.data.SaveBkgd));
set(handles.checkbox26,'Value',str2double(handles.data.OutDia));
set(handles.checkbox27,'Value',str2double(handles.data.OutDen));
set(handles.checkbox28,'Value',str2double(handles.data.OutLM));
set(handles.checkbox29,'Value',str2double(handles.data.OutCorr));
set(handles.checkbox30,'Value',str2double(handles.data.OutRatio));
set(handles.popupmenu4,'Value',str2double(handles.data.imNum));
set(handles.popupmenu12,'Value',str2double(handles.data.DiaGS));

%Make extension box red if '.' is included
if strcmp(handles.data.imext(1),'.')
    set(handles.edit35,'backgroundcolor','r');
else
    set(handles.edit35,'backgroundcolor',[1 1 1]);
end
%If no text in 'Image File Directory' make red 
if isempty(dir(handles.data.imdirec))
    set(handles.edit32,'backgroundcolor','r');
else
    set(handles.edit32,'backgroundcolor',[1 1 1]);
end
%====================================================%
%Following loops make text boxes red if value inside is negative
%-------------------------------------------------
if str2double(get(handles.edit48,'String'))<=0
    set(handles.edit48,'backgroundcolor','r')
else
    set(handles.edit48,'backgroundcolor',[1 1 1])
end
%-------------------------------------------------
if str2double(get(handles.edit26,'String'))<=0
    set(handles.edit26,'backgroundcolor','r')
else
    set(handles.edit26,'backgroundcolor',[1 1 1])
end
%====================================================%
%If Hardcode box is not checked, make text box gray
if str2double(handles.data.hardDia)==0
    set(handles.edit26,'backgroundcolor',0.5*[1 1 1]);
else
    set(handles.edit26,'backgroundcolor',[1 1 1]);
end
%-------------------------------------------------
if str2double(handles.data.hardDens)==0
    set(handles.edit48,'backgroundcolor',0.5*[1 1 1]);
else
    set(handles.edit48,'backgroundcolor',[1 1 1]);
end
%-------------------------------------------------
if str2double(handles.data.par)==0
    set(handles.edit69,'backgroundcolor',0.5*[1 1 1]);
else
    set(handles.edit69,'backgroundcolor',[1 1 1]);
end
%====================================================%

%% Update all data
function handles=update_data(handles)
if str2double(handles.Njob)==0
    set(handles.listbox4,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.listbox5,'String','','backgroundcolor','r');
    set(handles.edit26,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit31,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit32,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit33,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit34,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit35,'String','','backgroundcolor',0.5*[1 1 1]);
%     set(handles.edit36,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit37,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit38,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit39,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit42,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit44,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit48,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit69,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.popupmenu4,'Value',1,'backgroundcolor',0.5*[1 1 1]);
    set(handles.popupmenu12,'Value',1,'backgroundcolor',0.5*[1 1 1]);
    set(handles.checkbox16,'Value',0,'backgroundcolor',handles.syscolor);
else
    a=get(handles.listbox5,'String');
    eval(['handles.data=handles.' char(a(str2double(handles.Cjob),:)) ';'])
    set(handles.listbox4,'String','','backgroundcolor',[1 1 1]);
    set(handles.listbox5,'backgroundcolor',[1 1 1]);
    set(handles.edit26,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit31,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit32,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit33,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit34,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit35,'String','','backgroundcolor',[1 1 1]);
%     set(handles.edit36,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit37,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit38,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit39,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit42,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit44,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit48,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit69,'String','','backgroundcolor',[1 1 1]);
    set(handles.popupmenu4,'Value',1,'backgroundcolor',[1 1 1]);
    set(handles.popupmenu12,'Value',2,'backgroundcolor',[1 1 1]);
    load_imlist(handles);
    load_data(handles);
end


%% select job file
function listbox5_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    Jlist=char(get(handles.listbox5,'String'));
    eval(['handles.' Jlist(str2double(handles.Cjob),:) '=handles.data;']);
    handles.Cjob=num2str(get(hObject,'Value'));
    handles=update_data(handles);
    guidata(hObject,handles)
end
function listbox5_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Particle Density
function edit48_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.dens = get(hObject,'String');
    guidata(hObject,handles)
    if str2double(get(hObject,'String'))<=0
        set(hObject,'backgroundcolor','r')
    else
        set(hObject,'backgroundcolor',[1 1 1])
    end
end
function edit48_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% File Menu
function Untitled_1_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    set(handles.Untitled_5,'Enable','on')
    set(handles.Untitled_6,'Enable','on')
    set(handles.Untitled_12,'Enable','on')
else
    set(handles.Untitled_5,'Enable','off')
    set(handles.Untitled_6,'Enable','off')
    set(handles.Untitled_12,'Enable','off')
end


%% New Job
function Untitled_2_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    Jlist=char(get(handles.listbox5,'String'));
    eval(['handles.' Jlist(str2double(handles.Cjob),:) '=handles.data;']);
end
Data=handles.data0;
vn=0;
Data.batchname=char(inputdlg('Job Name?                  ','NEW JOB',1,{['PIV' num2str(str2double(handles.Njob)+1)]}));
if isempty(Data.batchname)
    vn=-1;
end
while vn==0
    if isfield(handles,Data.batchname)
        Data.batchname=char(inputdlg('Job already exists, rename?','NEW JOB',1,{['PIV' num2str(str2double(handles.Njob)+1)]}));
        if isempty(Data.batchname)
            vn=-1;
        end
    else
        handles=setfield(handles,Data.batchname,Data);
        vn=1;
    end
end
if vn~=-1
    if str2double(handles.Njob)>0
        Jlist=char(get(handles.listbox5,'String'));
        Jlist={Jlist;Data.batchname};
    else
        Jlist={Data.batchname};
    end
    handles.Njob=num2str(str2double(handles.Njob)+1);
    handles.Cjob=handles.Njob;
    set(handles.listbox5,'String',Jlist,'Value',str2double(handles.Cjob));
    handles=update_data(handles);
    guidata(hObject,handles)
end


%% Load Job
function Untitled_4_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    Jlist=char(get(handles.listbox5,'String'));
    eval(['handles.' Jlist(str2double(handles.Cjob),:) '=handles.data;']);
end
handlesP=handles;
[f,handles.loaddirec]=uigetfile('*.mat','LOAD JOB',handles.loaddirec,'multiselect','on');
if ischar(f)==1
    f={f};
else
    f=sort(f);
end
if isnumeric(f)==0
    try
        for pp=1:length(f)
            load([handles.loaddirec char(f(pp))]);
            if exist('Data')~=0
                vn=0;
                while vn==0
                    if isfield(handles,Data.batchname)
                        Data.batchname=char(inputdlg('Job already exists, rename?','LOAD JOB',1,{Data.batchname}));
                        if isempty(Data.batchname)
                            vn=-1;
                        end
                    else
                        handles=setfield(handles,Data.batchname,Data);
                        vn=1;
                    end
                end
                if vn~=-1
                    if str2double(handles.Njob)>0
                        Jlist=char(get(handles.listbox5,'String'));
                        Jlist={Jlist;Data.batchname};
                    else
                        Jlist={Data.batchname};
                    end
                    handles.Njob=num2str(str2double(handles.Njob)+1);
                    handles.Cjob=handles.Njob;
                    set(handles.listbox5,'String',Jlist,'Value',str2double(handles.Cjob));

                    handles=update_data(handles);
                    guidata(hObject,handles)
                end
            end
        end
    catch
        handles=handlesP;
        handles=update_data(handles);
        guidata(hObject,handles)
        beep,disp('ERROR: Invalid Data Format, Reloading Previous Settings')
    end
end


%% Save Job
function Untitled_5_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    Data=handles.data;
    uisave('Data',[handles.loaddirec handles.data.batchname '.mat']);
end


%% Delete Job
function Untitled_6_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    del=questdlg('Are You Sure?','Delete Job File','yes','no','yes');
    if strcmp(del,'yes')==1
        Jlist=char(get(handles.listbox5,'String'));
        handles=rmfield(handles,Jlist(str2double(handles.Cjob),:));
        id=setdiff(1:str2double(handles.Njob),str2double(handles.Cjob));
        Jlist=Jlist(id,:);
        set(handles.listbox5,'String',Jlist,'Value',1);
        handles.Cjob='1';
        handles.Njob=num2str(str2double(handles.Njob)-1);
        handles=update_data(handles);
        guidata(hObject,handles)
    end
end


%% Run Job
function Untitled_10_Callback(hObject, eventdata, handles)
tic
if str2double(handles.Njob)>0
    Data=handles.data;
    if ispc
        save([Data.outdirec '\' Data.batchname '_DiadenJob.mat'],'Data');
    else
        save([Data.outdirec '/' Data.batchname '_DiadenJob.mat'],'Data');
    end
        %process the data
        PIVdiaden(Data);
end
comptime=toc;
fprintf('total job completion time... %0.2i:%0.2i:%0.2i',floor(comptime/3600),floor(rem(comptime,3600)/60),floor(rem(comptime,60)))
fprintf('\n----------------------------------------------------\n')


%% Run Job Push Button
function pushbutton25_Callback(hObject, eventdata, handles)
tic
if str2double(handles.Njob)>0
    Data=handles.data;
    if ispc
        save([Data.outdirec '\' Data.batchname '_DiadenJob.mat'],'Data');
    else
        save([Data.outdirec '/' Data.batchname '_DiadenJob.mat'],'Data');
    end
        %process the data
        PIVdiaden(Data);
end
comptime=toc;
fprintf('total job completion time... %0.2i:%0.2i:%0.2i',floor(comptime/3600),floor(rem(comptime,3600)/60),floor(rem(comptime,60)))
fprintf('\n----------------------------------------------------\n')


%% Run All
function Untitled_11_Callback(hObject, eventdata, handles)
tic
if str2double(handles.Njob)>0
    Jlist=char(get(handles.listbox5,'String'));
    for e=1:size(Jlist,1)
        Data=eval(['handles.' Jlist(e,:)]);
        if ispc
            save([Data.outdirec '\' Data.batchname '_DiadenJob.mat'],'Data');
        else
            save([Data.outdirec '/' Data.batchname '_DiadenJob.mat'],'Data');
        end
        %process the data
        PIVdiaden(Data);
    end
end
comptime=toc;
fprintf('total job completion time... %0.2i:%0.2i:%0.2i',floor(comptime/3600),floor(rem(comptime,3600)/60),floor(rem(comptime,60)))
fprintf('\n----------------------------------------------------\n')


%% --- Run all Jobs Push Button
function pushbutton26_Callback(hObject, eventdata, handles)
tic
if str2double(handles.Njob)>0
    Jlist=char(get(handles.listbox5,'String'));
    for e=1:size(Jlist,1)
        Data=eval(['handles.' Jlist(e,:)]);
        if ispc
            save([Data.outdirec '\' Data.batchname '_DiadenJob.mat'],'Data');
        else
            save([Data.outdirec '/' Data.batchname '_DiadenJob.mat'],'Data');
        end
        %process the data
        PIVdiaden(Data);
    end
end
comptime=toc;
fprintf('total job completion time... %0.2i:%0.2i:%0.2i',floor(comptime/3600),floor(rem(comptime,3600)/60),floor(rem(comptime,60)))
fprintf('\n----------------------------------------------------\n')



%% Execute Menu
function Untitled_8_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    set(handles.Untitled_10,'Enable','on')
    set(handles.Untitled_11,'Enable','on')
else
    set(handles.Untitled_10,'Enable','off')
    set(handles.Untitled_11,'Enable','off')
end


%% Copy Job
function Untitled_12_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    Jlist=char(get(handles.listbox5,'String'));
    eval(['handles.' Jlist(str2double(handles.Cjob),:) '=handles.data;']);
end
Data=handles.data;
vn=0;
Data.batchname=char(inputdlg('Job Name?                  ','NEW JOB',1,{[strtrim(Jlist(str2double(handles.Cjob),:) ) '_copy']}));
if isempty(Data.batchname)
    vn=-1;
end
while vn==0
    if isfield(handles,Data.batchname)
        Data.batchname=char(inputdlg('Job already exists, rename?','NEW JOB',1,{strtrim(Jlist(str2double(handles.Cjob),:))}));
        if isempty(Data.batchname)
            vn=-1;
        end
    else
        handles=setfield(handles,Data.batchname,Data);
        vn=1;
    end
end
if vn~=-1
    if str2double(handles.Njob)>0
        Jlist=char(get(handles.listbox5,'String'));
        Jlist={Jlist;Data.batchname};
    else
        Jlist={Data.batchname};
    end
    handles.Njob=num2str(str2double(handles.Njob)+1);
    handles.Cjob=handles.Njob;
    set(handles.listbox5,'String',Jlist,'Value',str2double(handles.Cjob));
    handles=update_data(handles);
    guidata(hObject,handles)
end


%% Number of Processors to Use for Parallel Processing
function edit69_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.parprocessors=get(hObject,'String');
    guidata(hObject,handles)
end
function edit69_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Help Button
function pushbutton23_Callback(hObject, eventdata, handles)
addpath('documentation')
PIVdiaden_help


%% Help Dropdown
function Untitled_13_Callback(hObject, eventdata, handles)
%% Help Dropdown Select
function Untitled_14_Callback(hObject, eventdata, handles)
addpath('documentation')
PIVdiaden_help


%% Output Diameter 
function checkbox26_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.OutDia=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
end


%% Output Density
function checkbox27_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.OutDen=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
end

%% Output local Max Density
function checkbox28_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.OutLM=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
end

%% Output Correlation Peak Height
function checkbox29_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.OutCorr=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
end

%% Output Diameter Ratio
function checkbox30_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.OutRatio=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
end
