%LAST UPDATED: 10/29/2014

function varargout = PIVuncertaintyGUI(varargin)
%     This file is part of PIVuncertaintyGUI, an open-source GUI-driven 
%     program for calculating the uncertainty in PIV measurments.
%     Copyright (C) 2012  Utah State University
% 
%     PIVuncertaintyGUI is free software: you can redistribute it and/or 
%     modify it under the terms of the GNU General Public License as 
%     published by the Free Software Foundation, either version 3 of the or
%     License, (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     If you did not receive a copy of the GNU General Public License
%     along with this program, see <http://www.gnu.org/licenses/>.

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @PIVuncertaintyGUI_OpeningFcn, ...
    'gui_OutputFcn',  @PIVuncertaintyGUI_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


%% opening funciton for figure
function PIVuncertaintyGUI_OpeningFcn(hObject, eventdata, handles, varargin)

handles.syscolor=get(hObject,'color');
handles.loaddirec=[pwd '\'];

%Reading information
handles.data.imdirec=pwd;
handles.data.imbase='B';
handles.data.imzeros='5';
handles.data.imext='im7';
handles.data.imfstep='1';
handles.data.imfstart='1';
handles.data.imfend='2';

handles.data.datadirec=pwd;
handles.data.database='B';
handles.data.datazeros='5';
handles.data.dataext='mat';
handles.data.datacstep='0';
handles.data.datafstep='1';
handles.data.datafstart='1';
handles.data.datafend='2';

handles.data.surfdirec=pwd;
handles.data.surfname=pwd;
%Write controls
handles.data.batchname='Proc1';
handles.data.bkgd='1';

% handles.data.corr = '2';
handles.data.Cor='radiobutton2';
handles.data.cpass='1';
handles.data.DiaGS='2';
handles.data.DenGS='2';
handles.data.denlimit = '0';
handles.data.dens='';
handles.data.diam='';
handles.data.CalcDia='1';
handles.data.CalcDen='1';
handles.data.hardDens='0';
handles.data.hardDia='0';
handles.data.imNum = '1';
handles.data.multifolders='0';
handles.data.matout='1';
handles.data.minDen='';
handles.data.outbase='B';
handles.data.outdirec=pwd;
handles.data.par='0';
handles.data.parprocessors = '6';
handles.data.passes='1';
handles.data.pltout='0';
handles.data.stats='0';
handles.data.statsOnly='0';
handles.data.vcNum='1';
handles.data.wrmag='1';
handles.data.wrsep='1';

handles.data0=handles.data;
handles.Njob=num2str(size(get(handles.listbox5,'String'),1));
handles.Cjob=num2str(get(handles.listbox5,'String'));
handles=rmfield(handles,'data');
handles=update_data(handles);
handles.output = hObject;
guidata(hObject, handles);

%output
function varargout = PIVuncertaintyGUI_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;


%% Diameter Grid Size
function popupmenu12_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.DiaGS= num2str(get(handles.popupmenu12,'Value'));
    guidata(hObject,handles)
end
function popupmenu12_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Density Grid Size
function popupmenu13_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.DenGS= num2str(get(handles.popupmenu13,'Value'));
    guidata(hObject,handles)
end
function popupmenu13_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Hardcode Diameter
function edit26_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.diam = get(hObject,'String');
    guidata(hObject,handles)
    if str2double(get(hObject,'String'))<=0
        set(hObject,'backgroundcolor','r')
    else
        set(hObject,'backgroundcolor',[1 1 1])
    end
end
function edit26_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Output Basename
function edit31_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.outbase = get(hObject,'String');
    guidata(hObject,handles)
end
function edit31_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Image File Directory
function edit32_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.imdirec = get(hObject,'String');
    
    listOfFiles = dir([handles.data.imdirec '\' handles.data.imbase '*.' handles.data.imext]);
    handles.data.imfend=num2str(numel(listOfFiles));
    set(handles.edit39,'string',handles.data.imfend);
    
    load_imlist(handles);
    guidata(hObject,handles)
end
function edit32_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Output Directory
function edit33_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.outdirec = get(hObject,'String');
    guidata(hObject,handles)
end
function edit33_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Select Output Directory Button
function pushbutton10_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    D = handles.data.outdirec;
    handles.data.outdirec = uigetdir(handles.data.outdirec);
    if handles.data.outdirec==0
        handles.data.outdirec = D;
    end
    set(handles.edit33,'string',handles.data.outdirec);
    guidata(hObject,handles)
end


%% Image Listbox
function listbox4_Callback(hObject, eventdata, handles)
function listbox4_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% image base name
function edit34_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.imbase = get(hObject,'String');
    load_imlist(handles);
    guidata(hObject,handles)
end
function edit34_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% image extension
function edit35_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.imext = get(hObject,'String');
    if strcmp(handles.data.imext(1),'.')
        set(hObject,'backgroundcolor','r');
    else
        set(hObject,'backgroundcolor',[1 1 1]);
    end
    load_imlist(handles);
    guidata(hObject,handles)
end
function edit35_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% %% image pair step
% function edit36_Callback(hObject, eventdata, handles)
% if str2double(handles.Njob)>0
%     handles.data.imcstep = get(hObject,'String');
%     load_imlist(handles);
%     guidata(hObject,handles)
% end
% function edit36_CreateFcn(hObject, eventdata, handles)
% if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%     set(hObject,'BackgroundColor','white');
% end


%% image frame step
function edit37_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.imfstep = get(hObject,'String');
    load_imlist(handles);
    guidata(hObject,handles)
end
function edit37_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% image frame start
function edit38_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.imfstart = get(hObject,'String');
    load_imlist(handles);
    guidata(hObject,handles)
end
function edit38_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% image frame end
function edit39_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.imfend = get(hObject,'String');
    load_imlist(handles);
    guidata(hObject,handles)
end
function edit39_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Scale Factor
function edit40_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.wrmag = get(hObject,'String');
    guidata(hObject,handles)
    if str2double(get(hObject,'String'))<=0
        set(hObject,'backgroundcolor','r')
    else
        set(hObject,'backgroundcolor',[1 1 1])
    end
end
function edit40_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Job Name
function edit42_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    Jlist0=char(get(handles.listbox5,'String'));
    handles=rmfield(handles,handles.data.batchname);
    handles.data.batchname = get(hObject,'String');
    Jlist=cell(str2double(handles.Njob),1);
    for e=1:str2double(handles.Njob)
        if e==str2double(handles.Cjob)
            Jlist(e)={handles.data.batchname};
        else
            Jlist(e)={Jlist0(e,:)};
        end
    end    
    handles=setfield(handles,handles.data.batchname,handles.data);
    set(handles.listbox5,'String',char(Jlist));
    guidata(hObject,handles)
end
function edit42_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% pulse separation (dt)
function edit43_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.wrsep = get(hObject,'String');
    guidata(hObject,handles)
    if str2double(get(hObject,'String'))<=0
        set(hObject,'backgroundcolor','r')
    else
        set(hObject,'backgroundcolor',[1 1 1])
    end
end
function edit43_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% image file zeros
function edit44_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.imzeros = get(hObject,'String');
    load_imlist(handles);
    guidata(hObject,handles)
end
function edit44_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Run in Parallel
function checkbox16_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.par=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
    if str2double(handles.data.par)==0
        set(handles.edit69,'backgroundcolor',0.5*[1 1 1]);
    else
        set(handles.edit69,'backgroundcolor',[1 1 1]);
    end 
end


%% Stats Density Limit
function checkbox26_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.denlimit=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
    if str2double(handles.data.denlimit)==0
        set(handles.edit71,'backgroundcolor',0.5*[1 1 1]);
    else
        set(handles.edit71,'backgroundcolor',[1 1 1]);
    end 
end

%% Stats Minimum Density 
function edit71_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.minDen=get(hObject,'String');
    guidata(hObject,handles)
end
function edit71_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Particle Density Hardcode
function checkbox18_Callback(hObject, eventdata, handles)

    set(hObject,'Value',1)
    set(handles.checkbox28,'Value',0)
    handles.data.CalcDen = '0';
    set(handles.uipanel17,'Visible','on')
    set(handles.uipanel18,'Visible','off')
    
if str2double(handles.Njob)>0
    handles.data.hardDens=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
    if str2double(handles.data.hardDens)==0
        set(handles.edit48,'backgroundcolor',0.5*[1 1 1]);
    else
        set(handles.edit48,'backgroundcolor',[1 1 1]);
    end
end

%% Calculate Density Checkbox
function checkbox28_Callback(hObject, eventdata, handles)
set(hObject,'Value',1)
set(handles.checkbox18,'Value',0)
handles.data.hardDens = '0';
set(handles.uipanel17,'Visible','off')
set(handles.uipanel18,'Visible','on')
if str2double(handles.Njob)>0
    handles.data.CalcDen=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
end


%% Particle Diameter Hardcode
function checkbox19_Callback(hObject, eventdata, handles)
set(hObject,'Value',1)
set(handles.checkbox29,'Value',0)
handles.data.CalcDia = '0';
set(handles.uipanel25,'Visible','on')
set(handles.uipanel26,'Visible','off')
    
if str2double(handles.Njob)>0
    handles.data.hardDia=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
    if str2double(handles.data.hardDia)==0
        set(handles.edit26,'backgroundcolor',0.5*[1 1 1]);
    else
        set(handles.edit26,'backgroundcolor',[1 1 1]);
    end  
end


%% Calculate Diameter Checkbox
function checkbox29_Callback(hObject, eventdata, handles)
set(hObject,'Value',1)
set(handles.checkbox19,'Value',0)
handles.data.hardDia = '0';
set(handles.uipanel25,'Visible','off')
set(handles.uipanel26,'Visible','on')
if str2double(handles.Njob)>0
    handles.data.CalcDia=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
end


%% Mulitple Images per image
function checkbox25_Callback(hObject, eventdata, handles)
% set(hObject,'Value',1)
set(handles.checkbox14,'Value',0)
set(handles.checkbox17,'Value',0)
handles.data.stats = '0';
handles.data.statsOnly = '0';
if str2double(handles.Njob)>0
    handles.data.multifolders=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
end

%% Vector statistics switch
function checkbox14_Callback(hObject, eventdata, handles)
% set(hObject,'Value',1)
set(handles.checkbox25,'Value',0)
set(handles.checkbox17,'Value',0)
handles.data.multifolders = '0';
handles.data.statsOnly = '0';
if str2double(handles.Njob)>0
    handles.data.stats = num2str(get(hObject,'Value'));
    guidata(hObject,handles)
end

%% Compute Stats only
function checkbox17_Callback(hObject, eventdata, handles)
% set(hObject,'Value',1)
set(handles.checkbox25,'Value',0)
set(handles.checkbox14,'Value',0)
handles.data.multifolders = '0';
handles.data.stats = '0';
if str2double(handles.Njob)>0
    handles.data.statsOnly = num2str(get(hObject,'Value'));
    guidata(hObject,handles)
end


%% load IM list
function load_imlist(handles)
dir_struct = dir(handles.data.imdirec);
if isempty(dir_struct)
    set(handles.edit32,'backgroundcolor','r');
else
    set(handles.edit32,'backgroundcolor',[1 1 1]);
end
N=length(str2double(handles.data.imfstart):str2double(handles.data.imfstep):str2double(handles.data.imfend));
files = cell(N,1);
e=0;
for f=str2double(handles.data.imfstart):str2double(handles.data.imfstep):str2double(handles.data.imfend)
    e=e+1;
    files(e,1)={[handles.data.imbase sprintf(['%0.' handles.data.imzeros 'i.' handles.data.imext],f)]};
end

sorted_names = sortrows({dir_struct.name}');
[files1,id,id1] = intersect(sorted_names,files(:,1));

if isempty(id1)
    set(handles.listbox4,'backgroundcolor','r');
else
    set(handles.listbox4,'backgroundcolor',[1 1 1]);
    if length(id1)~=size(files,1)
        set(handles.listbox4,'backgroundcolor','r');
    end
end
files=files(id1,:);
filesf=cell(length(files),1);
for e=1:size(files,1)
    filesf(e)={char(files(e,1))};% ' and ' char(files(e,2))]};
end
set(handles.listbox4,'String',filesf,'Value',1)


%% load Data list
function load_datalist(handles)
dir_struct = dir(handles.data.datadirec);
if isempty(dir_struct)
    set(handles.edit61,'backgroundcolor','r');
else
    set(handles.edit61,'backgroundcolor',[1 1 1]);
end
N=length(str2double(handles.data.datafstart):str2double(handles.data.datafstep):str2double(handles.data.datafend));
files = cell(N,1);
e=0;
for f=str2double(handles.data.datafstart):str2double(handles.data.datafstep):str2double(handles.data.datafend)
    e=e+1;
    files(e,1)={[handles.data.database sprintf(['%0.' handles.data.datazeros 'i.' handles.data.dataext],f)]};
end

sorted_names = sortrows({dir_struct.name}');
[files1,id,id1] = intersect(sorted_names,files(:,1));

if isempty(id1)
    set(handles.listbox7,'backgroundcolor','r');
else
    set(handles.listbox7,'backgroundcolor',[1 1 1]);
    if length(id1)~=size(files,1)
        set(handles.listbox7,'backgroundcolor','r');
    end
end
files=files(id1,:);
filesf=cell(length(files),1);
for e=1:size(files,1)
    filesf(e)={char(files(e,1))};
end
set(handles.listbox7,'String',filesf,'Value',1)


%% load extra data
function [handles]=load_data(handles)
set(handles.edit26,'String',handles.data.diam);

set(handles.edit31,'String',handles.data.outbase);
set(handles.edit32,'String',handles.data.imdirec);
set(handles.edit33,'String',handles.data.outdirec);
set(handles.edit34,'String',handles.data.imbase);
set(handles.edit35,'String',handles.data.imext);
% set(handles.edit36,'String',handles.data.imcstep);
set(handles.edit37,'String',handles.data.imfstep);
set(handles.edit38,'String',handles.data.imfstart);
set(handles.edit39,'String',handles.data.imfend);
set(handles.edit40,'String',handles.data.wrmag);
set(handles.edit42,'String',handles.data.batchname);
set(handles.edit43,'String',handles.data.wrsep);
set(handles.edit44,'String',handles.data.imzeros);
set(handles.edit48,'String',handles.data.dens);
set(handles.edit61,'String',handles.data.datadirec);
set(handles.edit62,'String',handles.data.database);
set(handles.edit63,'String',handles.data.dataext);
set(handles.edit65,'String',handles.data.datafstep);
set(handles.edit66,'String',handles.data.datafstart);
set(handles.edit67,'String',handles.data.datafend);
set(handles.edit68,'String',handles.data.datazeros);
set(handles.edit69,'String',handles.data.parprocessors);
set(handles.edit71,'String',handles.data.minDen);
set(handles.edit72,'String',handles.data.surfname);
set(handles.checkbox14,'Value',str2double(handles.data.stats));
set(handles.checkbox16,'Value',str2double(handles.data.par));
set(handles.checkbox25,'Value',str2double(handles.data.multifolders));
set(handles.checkbox26,'Value',str2double(handles.data.denlimit));
% set(handles.checkbox27,'Value',str2double(handles.data.stereo));
set(handles.checkbox17,'Value',str2double(handles.data.statsOnly));
set(handles.checkbox18,'Value',str2double(handles.data.hardDens));
set(handles.checkbox19,'Value',str2double(handles.data.hardDia));
set(handles.checkbox23,'Value',str2double(handles.data.bkgd));
set(handles.checkbox28,'Value',str2double(handles.data.CalcDen));
set(handles.checkbox29,'Value',str2double(handles.data.CalcDia));
set(handles.pltout,'Value',str2double(handles.data.pltout));
set(handles.matout,'Value',str2double(handles.data.matout));
set(handles.popupmenu12,'Value',str2double(handles.data.DiaGS));
set(handles.popupmenu13,'Value',str2double(handles.data.DenGS));
set(handles.popupmenu14,'Value',str2double(handles.data.imNum));
set(handles.popupmenu15,'Value',str2double(handles.data.vcNum));

%Make extension box red if '.' is included
if strcmp(handles.data.imext(1),'.')
    set(handles.edit35,'backgroundcolor','r');
else
    set(handles.edit35,'backgroundcolor',[1 1 1]);
end
%Make extension box red if '.' is included
if strcmp(handles.data.dataext(1),'.')
    set(handles.edit63,'backgroundcolor','r');
else
    set(handles.edit63,'backgroundcolor',[1 1 1]);
end
%If no text in 'Image File Directory' make red 
if isempty(dir(handles.data.imdirec))
    set(handles.edit32,'backgroundcolor','r');
else
    set(handles.edit32,'backgroundcolor',[1 1 1]);
end
%If no text in 'Image File Directory' make red 
if isempty(dir(handles.data.datadirec))
    set(handles.edit61,'backgroundcolor','r');
else
    set(handles.edit61,'backgroundcolor',[1 1 1]);
end
%If no text in 'Surf File Directory' make red 
if isempty(dir(handles.data.surfdirec))
    set(handles.edit72,'backgroundcolor','r');
else
    set(handles.edit72,'backgroundcolor',[1 1 1]);
end
%====================================================%
%Following 4 loops make text boxes red if value inside is negative
if str2double(get(handles.edit40,'String'))<=0
    set(handles.edit40,'backgroundcolor','r')
else
    set(handles.edit40,'backgroundcolor',[1 1 1])
end
%-------------------------------------------------
if str2double(get(handles.edit43,'String'))<=0
    set(handles.edit43,'backgroundcolor','r')
else
    set(handles.edit43,'backgroundcolor',[1 1 1])
end
%-------------------------------------------------
if str2double(get(handles.edit48,'String'))<=0
    set(handles.edit48,'backgroundcolor','r')
else
    set(handles.edit48,'backgroundcolor',[1 1 1])
end
%-------------------------------------------------
if str2double(get(handles.edit26,'String'))<=0
    set(handles.edit26,'backgroundcolor','r')
else
    set(handles.edit26,'backgroundcolor',[1 1 1])
end
%====================================================%
%If Hardcode box is not checked, make text box gray
if str2double(handles.data.hardDia)==0
    set(handles.edit26,'backgroundcolor',0.5*[1 1 1]);
else
    set(handles.edit26,'backgroundcolor',[1 1 1]);
end
%-------------------------------------------------
if str2double(handles.data.hardDens)==0
    set(handles.edit48,'backgroundcolor',0.5*[1 1 1]);
else
    set(handles.edit48,'backgroundcolor',[1 1 1]);
end
%-------------------------------------------------
if str2double(handles.data.par)==0
    set(handles.edit69,'backgroundcolor',0.5*[1 1 1]);
else
    set(handles.edit69,'backgroundcolor',[1 1 1]);
end
%-------------------------------------------------
if str2double(handles.data.denlimit)==0
    set(handles.edit71,'backgroundcolor',0.5*[1 1 1]);
else
    set(handles.edit71,'backgroundcolor',[1 1 1]);
end
%-------------------------------------------------
% if str2double(handles.data.stereo)==0
%     set(handles.popupmenu15,'backgroundcolor',0.5*[1 1 1]);
% else
%     set(handles.popupmenu15,'backgroundcolor',[1 1 1]);
% end
%====================================================%

%% Update all data
function handles=update_data(handles)
if str2double(handles.Njob)==0
    set(handles.listbox4,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.listbox5,'String','','backgroundcolor','r');
    set(handles.listbox7,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit26,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit31,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit32,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit33,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit34,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit35,'String','','backgroundcolor',0.5*[1 1 1]);
%     set(handles.edit36,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit37,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit38,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit39,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit40,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit42,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit43,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit44,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit48,'String','','backgroundcolor',0.5*[1 1 1]);
    
    set(handles.edit61,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit62,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit63,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit65,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit66,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit67,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit68,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit69,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit71,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.edit72,'String','','backgroundcolor',0.5*[1 1 1]);
    set(handles.checkbox14,'Value',0,'backgroundcolor',handles.syscolor);
    set(handles.popupmenu12,'Value',1,'backgroundcolor',0.5*[1 1 1]);
    set(handles.popupmenu13,'Value',1,'backgroundcolor',0.5*[1 1 1]);
    set(handles.popupmenu14,'Value',1,'backgroundcolor',0.5*[1 1 1]);
    set(handles.popupmenu15,'Value',1,'backgroundcolor',0.5*[1 1 1]);
    set(handles.checkbox16,'Value',0,'backgroundcolor',handles.syscolor);
    
    set(handles.pltout,'Value',0,'backgroundcolor',handles.syscolor);
    set(handles.matout,'Value',1,'backgroundcolor',handles.syscolor);
else
    a=get(handles.listbox5,'String');
    eval(['handles.data=handles.' char(a(str2double(handles.Cjob),:)) ';'])
    set(handles.listbox4,'String','','backgroundcolor',[1 1 1]);
    set(handles.listbox5,'backgroundcolor',[1 1 1]);
    set(handles.listbox7,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit26,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit31,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit32,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit33,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit34,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit35,'String','','backgroundcolor',[1 1 1]);
%     set(handles.edit36,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit37,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit38,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit39,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit40,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit42,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit43,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit44,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit48,'String','','backgroundcolor',[1 1 1]);
    
    set(handles.edit61,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit62,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit63,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit65,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit66,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit67,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit68,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit69,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit71,'String','','backgroundcolor',[1 1 1]);
    set(handles.edit72,'String','','backgroundcolor',[1 1 1]);
    set(handles.popupmenu12,'Value',2,'backgroundcolor',[1 1 1]);
    set(handles.popupmenu13,'Value',2,'backgroundcolor',[1 1 1]);
    set(handles.popupmenu14,'Value',2,'backgroundcolor',[1 1 1]);
    set(handles.popupmenu15,'Value',2,'backgroundcolor',[1 1 1]);
    load_imlist(handles);
    load_datalist(handles);
    load_data(handles);
end


%% Job Listbox
function listbox5_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    Jlist=char(get(handles.listbox5,'String'));
    eval(['handles.' Jlist(str2double(handles.Cjob),:) '=handles.data;']);
    handles.Cjob=num2str(get(hObject,'Value'));
    handles=update_data(handles);
    guidata(hObject,handles)
end
function listbox5_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Particle Density Hardcode
function edit48_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.dens = get(hObject,'String');
    guidata(hObject,handles)
    if str2double(get(hObject,'String'))<=0
        set(hObject,'backgroundcolor','r')
    else
        set(hObject,'backgroundcolor',[1 1 1])
    end
end
function edit48_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% File Menu
function Untitled_1_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    set(handles.Untitled_5,'Enable','on')
    set(handles.Untitled_6,'Enable','on')
    set(handles.Untitled_12,'Enable','on')
else
    set(handles.Untitled_5,'Enable','off')
    set(handles.Untitled_6,'Enable','off')
    set(handles.Untitled_12,'Enable','off')
end


%% New Job
function Untitled_2_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    Jlist=char(get(handles.listbox5,'String'));
    eval(['handles.' Jlist(str2double(handles.Cjob),:) '=handles.data;']);
end
Data=handles.data0;
vn=0;
Data.batchname=char(inputdlg('Job Name?                  ','NEW JOB',1,{['PIV' num2str(str2double(handles.Njob)+1)]}));
if isempty(Data.batchname)
    vn=-1;
end
while vn==0
    if isfield(handles,Data.batchname)
        Data.batchname=char(inputdlg('Job already exists, rename?','NEW JOB',1,{['PIV' num2str(str2double(handles.Njob)+1)]}));
        if isempty(Data.batchname)
            vn=-1;
        end
    else
        handles=setfield(handles,Data.batchname,Data);
        vn=1;
    end
end
if vn~=-1
    if str2double(handles.Njob)>0
        Jlist=char(get(handles.listbox5,'String'));
        Jlist={Jlist;Data.batchname};
    else
        Jlist={Data.batchname};
    end
    handles.Njob=num2str(str2double(handles.Njob)+1);
    handles.Cjob=handles.Njob;
    set(handles.listbox5,'String',Jlist,'Value',str2double(handles.Cjob));
    handles=update_data(handles);
    guidata(hObject,handles)
end


%% Load Job
function Untitled_4_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    Jlist=char(get(handles.listbox5,'String'));
    eval(['handles.' Jlist(str2double(handles.Cjob),:) '=handles.data;']);
end
handlesP=handles;
[f,handles.loaddirec]=uigetfile('*.mat','LOAD JOB',handles.loaddirec,'multiselect','on');
if ischar(f)==1
    f={f};
else
    f=sort(f);
end
if isnumeric(f)==0
    try
        for pp=1:length(f)
            load([handles.loaddirec char(f(pp))]);
            if exist('Data')~=0
                vn=0;
                while vn==0
                    if isfield(handles,Data.batchname)
                        Data.batchname=char(inputdlg('Job already exists, rename?','LOAD JOB',1,{Data.batchname}));
                        if isempty(Data.batchname)
                            vn=-1;
                        end
                    else
                        handles=setfield(handles,Data.batchname,Data);
                        vn=1;
                    end
                end
                if vn~=-1
                    if str2double(handles.Njob)>0
                        Jlist=char(get(handles.listbox5,'String'));
                        Jlist={Jlist;Data.batchname};
                    else
                        Jlist={Data.batchname};
                    end
                    handles.Njob=num2str(str2double(handles.Njob)+1);
                    handles.Cjob=handles.Njob;
                    set(handles.listbox5,'String',Jlist,'Value',str2double(handles.Cjob));

                    handles=update_data(handles);
                    guidata(hObject,handles)
                end
            end
        end
    catch
        handles=handlesP;
        handles=update_data(handles);
        guidata(hObject,handles)
        beep,disp('ERROR: Invalid Data Format, Reloading Previous Settings')
    end
end

%% Save Job
function Untitled_5_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    Data=handles.data;
    uisave('Data',[handles.loaddirec handles.data.batchname '.mat']);
end


%% Delete Job
function Untitled_6_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    del=questdlg('Are You Sure?','Delete Job File','yes','no','yes');
    if strcmp(del,'yes')==1
        Jlist=char(get(handles.listbox5,'String'));
        handles=rmfield(handles,Jlist(str2double(handles.Cjob),:));
        id=setdiff(1:str2double(handles.Njob),str2double(handles.Cjob));
        Jlist=Jlist(id,:);
        set(handles.listbox5,'String',Jlist,'Value',1);
        handles.Cjob='1';
        handles.Njob=num2str(str2double(handles.Njob)-1);
        handles=update_data(handles);
        guidata(hObject,handles)
    end
end


%% Run Job
function Untitled_10_Callback(hObject, eventdata, handles)
tic

if str2double(handles.Njob)>0
    Data=handles.data;
    if ispc
        save([Data.outdirec '\' Data.batchname '_Job.mat'],'Data');
    else
        save([Data.outdirec '/' Data.batchname '_Job.mat'],'Data');
    end
    if str2double(Data.statsOnly) ==0
        %process the data
        PIVuncertaintyCode(Data);
        %compute vector statistics
        if str2double(Data.stats)==1
            PIV_Stats(Data);
        end
    else
        PIV_Stats(Data);
    end
end

comptime=toc;
fprintf('total job completion time... %0.2i:%0.2i:%0.2i',floor(comptime/3600),floor(rem(comptime,3600)/60),floor(rem(comptime,60)))
fprintf('\n----------------------------------------------------\n')


%% Run Job Push Button
function pushbutton25_Callback(hObject, eventdata, handles)
tic

if str2double(handles.Njob)>0
    Data=handles.data;
    if ispc
        save([Data.outdirec '\' Data.batchname '_Job.mat'],'Data');
    else
        save([Data.outdirec '/' Data.batchname '_Job.mat'],'Data');
    end
    if str2double(Data.statsOnly) ==0
        %process the data
        PIVuncertaintyCode(Data);
        %compute vector statistics
        if str2double(Data.stats)==1
            PIV_Stats(Data);
        end
    else
        PIV_Stats(Data);
    end
end

comptime=toc;
fprintf('total job completion time... %0.2i:%0.2i:%0.2i',floor(comptime/3600),floor(rem(comptime,3600)/60),floor(rem(comptime,60)))
fprintf('\n----------------------------------------------------\n')


%% Run All
function Untitled_11_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    Jlist=char(get(handles.listbox5,'String'));
    for e=1:size(Jlist,1)
        Data=eval(['handles.' Jlist(e,:)]);
        if ispc
            save([Data.outdirec '\' Data.batchname '_Job.mat'],'Data');
        else
            save([Data.outdirec '/' Data.batchname '_Job.mat'],'Data');
        end
            if str2double(Data.statsOnly) ==0
                %process the data
                PIVuncertaintyCode(Data);
                %compute vector statistics
                if str2double(Data.stats)==1
                    PIV_Stats(Data);
                end
            else
                PIV_Stats(Data);
            end
        
    end
end


%% Run all Jobs Push Button
function pushbutton26_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    Jlist=char(get(handles.listbox5,'String'));
    for e=1:size(Jlist,1)
        Data=eval(['handles.' Jlist(e,:)]);
        if ispc
            save([Data.outdirec '\' Data.batchname '_Job.mat'],'Data');
        else
            save([Data.outdirec '/' Data.batchname '_Job.mat'],'Data');
        end
            if str2double(Data.statsOnly) ==0
                %process the data
                PIVuncertaintyCode(Data);
                %compute vector statistics
                if str2double(Data.stats)==1
                    PIV_Stats(Data);
                end
            else
                PIV_Stats(Data);
            end
        
    end
end


%% Execute Menu
function Untitled_8_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    set(handles.Untitled_10,'Enable','on')
    set(handles.Untitled_11,'Enable','on')
else
    set(handles.Untitled_10,'Enable','off')
    set(handles.Untitled_11,'Enable','off')
end

%% Copy Job
function Untitled_12_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    Jlist=char(get(handles.listbox5,'String'));
    eval(['handles.' Jlist(str2double(handles.Cjob),:) '=handles.data;']);
end
Data=handles.data;
vn=0;
Data.batchname=char(inputdlg('Job Name?                  ','NEW JOB',1,{[strtrim(Jlist(str2double(handles.Cjob),:) ) '_copy']}));
if isempty(Data.batchname)
    vn=-1;
end
while vn==0
    if isfield(handles,Data.batchname)
        Data.batchname=char(inputdlg('Job already exists, rename?','NEW JOB',1,{strtrim(Jlist(str2double(handles.Cjob),:))}));
        if isempty(Data.batchname)
            vn=-1;
        end
    else
        handles=setfield(handles,Data.batchname,Data);
        vn=1;
    end
end
if vn~=-1
    if str2double(handles.Njob)>0
        Jlist=char(get(handles.listbox5,'String'));
        Jlist={Jlist;Data.batchname};
    else
        Jlist={Data.batchname};
    end
    handles.Njob=num2str(str2double(handles.Njob)+1);
    handles.Cjob=handles.Njob;
    set(handles.listbox5,'String',Jlist,'Value',str2double(handles.Cjob));
    handles=update_data(handles);
    guidata(hObject,handles)
end


%% Data File Directory
function edit61_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.datadirec = get(hObject,'String');
    
    listOfFiles = dir([handles.data.datadirec '\' handles.data.database '*.' handles.data.dataext]);
    handles.data.datafend=num2str(numel(listOfFiles));
    set(handles.edit67,'string',handles.data.datafend);
    
    load_datalist(handles);
    guidata(hObject,handles)
end
function edit61_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% data base name
function edit62_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.database = get(hObject,'String');
    load_datalist(handles);
    guidata(hObject,handles)
end
function edit62_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% data extension
function edit63_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.dataext = get(hObject,'String');
    if strcmp(handles.data.dataext(1),'.')
        set(hObject,'backgroundcolor','r');
    else
        set(hObject,'backgroundcolor',[1 1 1]);
    end
    
    load_datalist(handles);
    guidata(hObject,handles)
end
function edit63_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% data frame step
function edit65_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.datafstep = get(hObject,'String');
    load_datalist(handles);
    guidata(hObject,handles)
end
function edit65_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% data frame start
function edit66_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.datafstart = get(hObject,'String');
    load_datalist(handles);
    guidata(hObject,handles)
end
function edit66_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% data frame end
function edit67_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.datafend = get(hObject,'String');
    load_datalist(handles);
    guidata(hObject,handles)
end
function edit67_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% data zeros
function edit68_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.datazeros = get(hObject,'String');
    load_datalist(handles);
    guidata(hObject,handles)
end
function edit68_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Data Processing Order Listbox
function listbox7_Callback(hObject, eventdata, handles)
function listbox7_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



%% Number of Processors to Use for Parallel Processing
function edit69_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.parprocessors=get(hObject,'String');
    guidata(hObject,handles)
end
function edit69_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Output plt File Checkbox
function pltout_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.pltout = num2str(get(hObject,'Value'));
    guidata(hObject,handles)
end


%% Output mat File Checkbox
function matout_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.matout = num2str(get(hObject,'Value'));
    guidata(hObject,handles)
end


%% Background Image Removal
function checkbox23_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.bkgd=num2str(get(hObject,'Value'));
    guidata(hObject,handles)
end


%% Help Button
function pushbutton23_Callback(hObject, eventdata, handles)
fprintf('\n----------------------------------------------------\n')
fprintf('PIVuncertainty Help not available')
fprintf('\n----------------------------------------------------\n')
% addpath('documentation')
% PIVuncertainty_help




%% Get DaVis dt and Scale Factor Button
function pushbutton30_Callback(hObject, eventdata, handles)
if strcmp(handles.data.imext,'im7')==1 || strcmp(handles.data.imext,'IM7')==1
    if strcmp(handles.data.dataext,'vc7')==1 || strcmp(handles.data.dataext,'VC7')==1
        if ispc
            imbase=[handles.data.imdirec '\' handles.data.imbase];
            database=[handles.data.datadirec '\' handles.data.database];
        else
            imbase=[handles.data.imdirec '/' handles.data.imbase];
            database=[handles.data.datadirec '/' handles.data.database];
        end
        
        Davis=readimx([imbase sprintf(['%0.' handles.data.imzeros 'i.' handles.data.imext],str2num(handles.data.imfstart))]);
        VC7 = readimx([database sprintf(['%0.' handles.data.datazeros 'i.' handles.data.dataext],str2num(handles.data.datafstart))]);
        sf=Davis.Frames{1,1}.Scales.X.Slope*1000;
        sf_check=VC7.Frames{1,1}.Scales.X.Slope*1000;
        
        if sf_check~=sf
            fprintf('Can not determine dt automatically. Please enter dt manually\n')
            sf
            sf_check
        end
        
        set(handles.edit40,'string',num2str(sf));     
        i=0;
        t0='empty';t1=t0;
        if strcmp(Davis.Frames{1,1}.Attributes{2,1}.Name,'AcqTime')
            t0= Davis.Frames{1,1}.Attributes{2,1}.Value;
        else
            i=0;
            while strcmp(t0,'empty')
                i=i+1;
                if strcmp(Davis.Frames{1,1}.Attributes{i,1}.Name,'AcqTime')
                  t0= Davis.Frames{1,1}.Attributes{i,1}.Value;
                end
            end
        end
        
        if strcmp(Davis.Frames{2,1}.Attributes{2,1}.Name,'AcqTime')
            t1= Davis.Frames{2,1}.Attributes{2,1}.Value;
        else
            i=0;
            while strcmp(t1,'empty')
               i=i+1;
               if strcmp(Davis.Frames{2,1}.Attributes{i,1}.Name,'AcqTime')
                  t1= Davis.Frames{2,1}.Attributes{i,1}.Value;
               end
            end
        end
        value0 = textscan(t0, '%s',1);
        value1 = textscan(t1, '%s',1);
        dt=str2double(value1{1,1})-str2double(value0{1,1});
        
        i=0;
        t2='empty';
        while strcmp(t2,'empty')
           i=i+1;
           if strcmp(VC7.Frames{1,1}.Attributes{i,1}.Name,'FrameDt')
              t2=    VC7.Frames{1,1}.Attributes{i,1}.Value;
           end            
        end
        value2 = textscan(t2, '%s',1);
        dt_check=str2double(value2{1,1});
        if dt_check~=dt
            fprintf('Can not determine dt automatically. Please enter dt manually\n')
            dt
            dt_check
        end
%         if sf==1000
%             VC7 = readimx([database sprintf(['%0.' handles.data.datazeros 'i.' handles.data.dataext],str2num(handles.data.datafstart))]);
%             sf=VC7.ScaleX(1)*1000; %[um]
%         end
%         if isnan(sf)
%             fprintf('Can not determine scale factor automatically. Please enter manually\n')
%             sf=NaN;
%         end
%         set(handles.edit40,'string',num2str(sf));       
%         dt0str=Davis.Attributes(strfind(Davis.Attributes,'AcqTime0=')+9:strfind(Davis.Attributes,'AcqTime0=')+9+9);
%         dt1str=Davis.Attributes(strfind(Davis.Attributes,'AcqTime1=')+9:strfind(Davis.Attributes,'AcqTime1=')+9+9);
%         dt0=str2double(dt0str(1:strfind(dt0str,'.')+2));
%         dt1=str2double(dt1str(1:strfind(dt1str,'.')+2));
%         dt=dt1-dt0;
%         davis=readimx([database sprintf(['%0.' handles.data.datazeros 'i.' handles.data.dataext],1)]);
%         if isnan(dt)
%         dt=str2num(davis.Attributes(strfind(davis.Attributes,'FrameDt0=')+9:strfind(davis.Attributes,' us')-1));%[us]
%         end
%         if isnan(dt)
%         VC7 = loadvec([database sprintf(['%0.' handles.data.datazeros 'i.' handles.data.dataext],str2num(handles.data.datafstart))]);
%         TempStrg=VC7.Attributes(strfind(VC7.Attributes,'FrameDt0='):strfind(VC7.Attributes,'FrameDt0=')+15); 
%         dt=str2double(TempStrg(strfind(TempStrg,'FrameDt0=')+9:strfind(TempStrg,'us')-1));
%         end
%         if isnan(dt)
%            dt=str2double(TempStrg(strfind(TempStrg,'FrameDt0=')+9:strfind(TempStrg,'µs')-1));
%         end
        if isnan(dt)
            fprintf('Can not determine dt automatically. Please enter dt manually\n')
        end
        
        set(handles.edit43,'string',num2str(dt));
        handles.data.wrmag=num2str(sf);
        handles.data.wrsep=num2str(dt);
        guidata(hObject,handles)
    end
end



%% Select First Image Button
function pushbutton24_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    D = handles.data.imdirec;
    B = handles.data.imbase;
    Z = handles.data.imzeros;
    E = handles.data.imext;
    S = handles.data.imfstart;
    F = handles.data.imfend;
    [imname,handles.data.imdirec] = uigetfile('*.*','Select an image file',handles.data.imdirec);
    handles.data.imdirec=handles.data.imdirec(1:end-1);
    if handles.data.imdirec==0
        handles.data.imdirec = D;
        handles.data.imbase = B;
        handles.data.imzeros = Z;
        handles.data.imext = E;
        handles.data.imfstart = S;
        handles.data.imfend = F;
    else
        i=strfind(imname,'.');
        handles.data.imext=imname((i+1):end);
        fstart=0;zeros=0;
        while ~isnan(fstart)
            zeros=zeros+1;
            fstart=str2double(imname((i-zeros):(i-1)));
        end
        handles.data.imzeros=num2str(zeros-1);
        fstart=str2double(imname((i-(zeros-1)):(i-1)));
        handles.data.imfstart=num2str(fstart);
        handles.data.imfend=num2str(fstart);
        handles.data.imbase=imname(1:(i-zeros));
    end
    set(handles.edit32,'string',handles.data.imdirec);
    set(handles.edit34,'string',handles.data.imbase);
    set(handles.edit44,'string',handles.data.imzeros);
    set(handles.edit35,'string',handles.data.imext);
    set(handles.edit38,'string',handles.data.imfstart);
    
    
    listOfFiles = dir([handles.data.imdirec '\' handles.data.imbase '*.' handles.data.imext]);
    handles.data.imfend=num2str(numel(listOfFiles));
    set(handles.edit39,'string',handles.data.imfend);
    
    load_imlist(handles);
    guidata(hObject,handles)
end


% --- Executes on button press in pushbutton29.
function pushbutton29_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    D = handles.data.datadirec;
    B = handles.data.database;
    Z = handles.data.datazeros;
    E = handles.data.dataext;
    S = handles.data.datafstart;
    F = handles.data.datafend;
    [imname,handles.data.datadirec] = uigetfile('*.*','Select an image file',handles.data.imdirec);
    handles.data.datadirec=handles.data.datadirec(1:end-1);
    if handles.data.imdirec==0
        handles.data.datadirec = D;
        handles.data.database = B;
        handles.data.datazeros = Z;
        handles.data.dataext = E;
        handles.data.datafstart = S;
        handles.data.datafend = F;
    else
        i=strfind(imname,'.');
        handles.data.dataext=imname((i+1):end);
        fstart=0;zeros=0;
        while ~isnan(fstart)
            zeros=zeros+1;
            fstart=str2double(imname((i-zeros):(i-1)));
        end
        handles.data.datazeros=num2str(zeros-1);
        fstart=str2double(imname((i-(zeros-1)):(i-1)));
        handles.data.datafstart=num2str(fstart);
        handles.data.datafend=num2str(fstart);
        handles.data.database=imname(1:(i-zeros));
    end
    set(handles.edit61,'string',handles.data.datadirec);
    set(handles.edit62,'string',handles.data.database);
    set(handles.edit68,'string',handles.data.datazeros);
    set(handles.edit63,'string',handles.data.dataext);
    set(handles.edit66,'string',handles.data.datafstart);
    
    listOfFiles = dir([handles.data.datadirec '\' handles.data.database '*.' handles.data.dataext]);
    handles.data.datafend=num2str(numel(listOfFiles));
    set(handles.edit67,'string',handles.data.datafend);

    load_datalist(handles);
    guidata(hObject,handles)
end


%% Select Image Frame
function popupmenu14_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.imNum= num2str(get(handles.popupmenu14,'Value'));
    guidata(hObject,handles)
end
function popupmenu14_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Using Split Stereo VC7 Files
% function checkbox27_Callback(hObject, eventdata, handles)
% if str2double(handles.Njob)>0
%     handles.data.stereo=num2str(get(hObject,'Value'));
%     guidata(hObject,handles)
%     if str2double(handles.data.stereo)==0
%         set(handles.popupmenu15,'backgroundcolor',0.5*[1 1 1]);
%     else
%         set(handles.popupmenu15,'backgroundcolor',[1 1 1]);
%     end 
% end


%% Select Camera
function popupmenu15_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.vcNum= num2str(get(handles.popupmenu15,'Value'));
    guidata(hObject,handles)
end
function popupmenu15_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Surface Directory
function edit72_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    handles.data.surfdirec = get(hObject,'String');
    load_datalist(handles);
    guidata(hObject,handles)
end
function edit72_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Surface Selection Button
function pushbutton32_Callback(hObject, eventdata, handles)
if str2double(handles.Njob)>0
    D = handles.data.surfdirec;
    [imname,handles.data.surfdirec] = uigetfile('*.*','Select an image file',handles.data.surfdirec);
    handles.data.surfdirec=handles.data.surfdirec(1:end-1);
    handles.data.surfname=imname;
    if handles.data.imdirec==0
        handles.data.surfdirec = D;
    end
    set(handles.edit72,'string',handles.data.surfname);
    load_datalist(handles);
    guidata(hObject,handles)
end



